'use strict';

const fs = require( 'fs' );
const mariadb = require( 'mariadb' );
const logger = require( './pipeline-logger.js' ).getPipelineLogger();

/**
 * Import properties into database
 *
 * @param {string} inputFilePath - file path to properties.json generated by ./get-properties.js
 * @param {Mixed} debugEnabled -  string from commanad, 'true' or ignored
 *
 * @return {Promise<void>}
 */
async function init( inputFilePath, debugEnabled ) {
	return new Promise( ( resolve ) => {
		// Destination of JSON file containing:
		// {
		//  "behaviors": [],
		//  "proxies": [],
		//  "tunnels": []
		// }
		const properties = require( inputFilePath );

		const pool = mariadb.createPool( {
			host: process.env.MYSQL_HOST,
			user: process.env.MYSQL_RW_USER,
			password: process.env.MYSQL_RW_PASS,
			database: process.env.MYSQL_DATABASE,
			port: process.env.MYSQL_PORT
		} );

		// Ensure that the queries have all completed before closing the pool. This
		// is called each time the counter is decremented.
		function maybeClosePool( counter ) {
			if ( counter === 0 ) {
				pool.end();
				resolve();
			}
		}

		// Set counter to the number of queries to perform. As each completes,
		// the counter is decremented, and when the counter reaches 0, we can
		// close the pool.
		let counter = properties.behaviors.length +
			properties.proxies.length +
			properties.tunnels.length;

		if ( !counter ) {
			maybeClosePool( counter );
		}

		try {
			properties.behaviors.forEach( async ( behavior ) => {
				const connection = await pool.getConnection();
				await connection.query( 'INSERT IGNORE INTO behaviors (behavior) VALUES (?);', [ behavior ] );
				counter--;
				connection.close();
				maybeClosePool( counter );
			} );
			properties.proxies.forEach( async ( proxy ) => {
				const connection = await pool.getConnection();
				await connection.query( 'INSERT IGNORE INTO proxies (proxy) VALUES (?);', [ proxy ] );
				counter--;
				connection.close();
				maybeClosePool( counter );
			} );

			// Ideally we should be running as many of these connections as the pool can sustain
			// but since the UNIQUE constraint doesn't work on NULL values, to avoid possibly
			// double-inserting a tunnel with a NULL `anonymous` value, run these synchronously
			// to ensure that the existence check will always be accurate.
			( async function () {
				for await ( const tunnel of properties.tunnels ) {
					const connection = await pool.getConnection();

					// If tunnel.anonymous is NULL, check if it's already been inserted
					// as unique constraints don't work on NULL values
					if ( tunnel.anonymous === null ) {
						let tunnelExists = await connection.query(
							'SELECT COUNT(operator) FROM tunnels WHERE operator = ? AND anonymous IS NULL',
							[ tunnel.operator, tunnel.anonymous ]
						);
						tunnelExists = Number( tunnelExists[ 0 ][ 'COUNT(operator)' ] );

						if ( !tunnelExists ) {
							await connection.query(
								'INSERT INTO tunnels (operator, type, anonymous) VALUES (?, ?, ?);',
								[ tunnel.operator, tunnel.type, tunnel.anonymous ]
							);
						}
					} else {
						await connection.query(
							'INSERT IGNORE INTO tunnels (operator, type, anonymous) VALUES (?, ?, ?);',
							[ tunnel.operator, tunnel.type, tunnel.anonymous ]
						);
					}
					counter--;
					connection.close();
					maybeClosePool( counter );
				}
			}() );

			// Clean up properties.json
			if ( debugEnabled !== 'true' ) {
				fs.unlinkSync( inputFilePath );
			}
		} catch ( e ) {
			logger.error(
				{
					err: e
				}
			);
		}
	} );
}

module.exports = init;
